local _

function DKPTooltip_OnLoad()

local DKPCOST_TEXT,DKPCOST_TEXT2 = "Full DKP-cost","Half DKP-cost"
types={"renovo","epgp","warmath"}

if(DKPT==nil) then
	DKPT={}
	DKPT['on']=true
	DKPT['half']=true
	DKPT['type']="renovo"
	DKPT['color']={
			tr=.45,
			tg=.45,
			tb=1,

			vr=.96,
			vg=.55,
			vb=.73,
			}
end

if(not tContains(types,DKPT['type'])) then
	DKPT['type']="renovo"
end

local name, link, quality, ilevel, reqlevel, itype, isubtype, maxstack, equipslot, texture
local itemInfo		-- item:itemID:enchant:gemID1:gemID2:gemID3:gemID4:suffixID:uniqueID:level:upgradeID:instanceDifficultyID:numBonusIDs:bonusID1:bonusID2:...

--[[
/run a={strsplit(":","")} a[#a]=string.match(a[#a],"%d+") for i,j in pairs(a) do print(i..": "..j) end
/run print(GetMouseFocus().link:gsub("\124","\124\124"))
/run print("\124cffa335ee\124Hitem:118939:0:0:0:0:0:0:0:100:0:0:0\124h[Crown of Destruction]\124h\124r")
/run print("\124cff0070dd\124Hitem:109761:0:0:0:0:0:0:0:100:0:0:2:40:524\124h[Bloodthorn Band]\124h\124r")
/run print("\124cff0070dd\124Hitem:109960:0:0:0:0:0:0:0:100:0:0:2:499:524\124h[Wavesurge Choker]\124h\124r")
/run print("\124cffa335ee\124Hitem:119014:5300:5345:0:0:0:0:0:100:0:0:3:146:560:563\124h[Doomchain Drape of the Deft]\124h\124r")
nil: no change
40 : avoidance
41 : leech
42 : speed
43 : indestructible
44 : warforged
146: prismatic socket
499: warforged
523: prismatic socket
524: heroic
560: warforged
566: heroic
567: mythic
569: mythic token
570: heroic

--]]

local function AddInfoToTooltip(tip, link)
	if(DKPT['on']) then
		local value=0
		name, link, quality, ilevel, reqlevel, itype, isubtype, maxstack, equipslot, texture, sellprice = GetItemInfo(link)
		if not link then
			return
		end
		itemInfo = {strsplit(":", link)}
		itemInfo[#itemInfo] = string.match(itemInfo[#itemInfo], "%d+")
		for k, v in pairs(itemInfo) do
			itemInfo[k] = tonumber(v)
		end
		if (itype == "Miscellaneous" and name:find(" of the ") and (name:find("Vanquisher") or name:find("Conqueror") or name:find("Protector"))) or equipslot == "INVTYPE_TOKEN" then
			equipslot = "INVTYPE_TOKEN"
			local diff, wf = 0, 0
			if itemInfo[13] then		-- number of bonusIDs
				for i = 1, itemInfo[13] do
					if itemInfo[13 + i] == 524 or 
						itemInfo[13 + i] == 566 or
						itemInfo[13 + i] == 570 then	-- heroic
						diff = 1
					elseif itemInfo[13 + i] == 567 or
						itemInfo[13 + i] == 569 then	-- mythic
						diff = 2
					elseif itemInfo[13 + i] == 44 or
						itemInfo[13 + i] == 499 or
						itemInfo[13 + i] == 560 then	-- wf
						wf = 1
					end
				end
			end
			ilevel = 665 + 15 * diff + 6 * wf
		end
		if equipslot=="" or ilevel==nil then
			return
		end
		local type=DKPT['type']
		if(type=="renovo") then
			local slot={
				INVTYPE_2HWEAPON		= 1.5,	-- two-hand weapons
				INVTYPE_RANGED			= 1.5,	-- bows
				INVTYPE_RANGEDRIGHT		= 1.5,	-- guns, crossbows, wands
				INVTYPE_WEAPON			= 1.2,	-- one-hand weapons
				INVTYPE_WEAPONMAINHAND	= 1.2,	-- main-hand weapons
				INVTYPE_WEAPONOFFHAND	= 1,	-- off-hand weapons

				INVTYPE_LEGS			= 1,	-- pants
				INVTYPE_CHEST			= 1,	-- chestpiece
				INVTYPE_ROBE			= 1,	-- chestpiece
				INVTYPE_HEAD			= 1,	-- hat
				INVTYPE_TRINKET			= 1,	-- trinkets
				
				INVTYPE_SHOULDER		= 0.9,	-- shoulderpads
				INVTYPE_HAND			= 0.9,	-- gloves
				INVTYPE_WAIST			= 0.9,	-- belt
				INVTYPE_FEET			= 0.9,	-- boots
				
				INVTYPE_WRIST			= 0.8,	-- wrists
				INVTYPE_NECK			= 0.8,	-- necks
				INVTYPE_FINGER			= 0.8,	-- rings
				INVTYPE_HOLDABLE		= 0.8,	-- held in off-hands
				INVTYPE_SHIELD			= 0.8,	-- off-hand shields
				INVTYPE_CLOAK			= 0.8,	-- cloaks

				INVTYPE_TOKEN			= 1,	-- speschuul case for tokens

								-- compatibility for old items
				INVTYPE_THROWN			= 0.5,	-- thrown weapons
				INVTYPE_RELIC			= 0.5,	-- relics

				k=0.43859649122807017543859649122807,
				m=-205.61403508771929824561403508772,
			}
			if slot[equipslot] ~= nil then
				ilevel = ilevel - 31
				value = (slot['k']*ilevel+slot['m'])*slot[equipslot]
				value = math.floor(value+0.5)
			end
		elseif(type=="epgp") then
			local slot={
				INVTYPE_2HWEAPON=2,
				INVTYPE_WEAPON=1.5,
				INVTYPE_WEAPONMAINHAND=1.5,
				INVTYPE_WEAPONOFFHAND=1.5,
		
				INVTYPE_LEGS=1,
				INVTYPE_CHEST=1,
				INVTYPE_ROBE=1,
				INVTYPE_HEAD=1,
		
				INVTYPE_SHOULDER=0.75,
				INVTYPE_HAND=0.75,
				INVTYPE_WAIST=0.75,
				INVTYPE_FEET=0.75,
				INVTYPE_TRINKET=0.75,
		
				INVTYPE_WRIST=0.5,
				INVTYPE_NECK=0.5,
				INVTYPE_CLOAK=0.5,
				INVTYPE_FINGER=0.5,
				INVTYPE_HOLDABLE=0.5,
				INVTYPE_SHIELD=0.5,
				INVTYPE_RANGED=0.5,
				INVTYPE_RANGEDRIGHT=0.5,
				INVTYPE_THROWN=0.5,
				INVTYPE_RELIC=0.5,	
		
				scaler=0.483
				}
			if(slot[equipslot]~=nil) then
				value=slot['scaler']*(2^(ilevel/26+(quality-4)))*slot[equipslot]
				value=value-value%5
			end
		elseif(type=="warmath") then
			local slot={
				INVTYPE_2HWEAPON=1,
				INVTYPE_WEAPON=0.5,
				INVTYPE_WEAPONMAINHAND=0.5,
				INVTYPE_WEAPONOFFHAND=0.5,
		
				INVTYPE_LEGS=1,
				INVTYPE_CHEST=1,
				INVTYPE_ROBE=1,
				INVTYPE_HEAD=1,
		
				INVTYPE_SHOULDER=0.74,
				INVTYPE_HAND=0.74,
				INVTYPE_WAIST=0.74,
				INVTYPE_FEET=0.74,
				INVTYPE_TRINKET=0.68,
		
				INVTYPE_WRIST=0.54,
				INVTYPE_NECK=0.54,
				INVTYPE_CLOAK=0.54,
				INVTYPE_FINGER=0.54,
				INVTYPE_HOLDABLE=0.5,
				INVTYPE_SHIELD=0.5,
				INVTYPE_RANGED=0.5,
				INVTYPE_RANGEDRIGHT=0.5,
				INVTYPE_THROWN=0.5,
				INVTYPE_RELIC=0.5
				}
			local qualm={
				_,
				1.21,
				1.42,
				1.64,
				1.86
				}
			local quala={
				_,
				-9.8,
				-4.2,
				11.2,
				26.2
				}
			if(slot[equipslot]~=nil) then
				value=((ilevel*qualm[quality])+quala[quality])*slot[equipslot]
				value=math.floor(value*10+0.5)/10
			end
		end
		if value <= 0 then
			return
		end
		tip:AddDoubleLine(DKPCOST_TEXT, value, DKPT['color']['tr'], DKPT['color']['tg'], DKPT['color']['tb'], DKPT['color']['vr'], DKPT['color']['vg'], DKPT['color']['vb'])
		if(DKPT['half']) then
			if(value%2==1) then
				tip:AddDoubleLine(DKPCOST_TEXT2, value/2+.5, DKPT['color']['tr'], DKPT['color']['tg'], DKPT['color']['tb'], DKPT['color']['vr'], DKPT['color']['vg'], DKPT['color']['vb'])
			else
				tip:AddDoubleLine(DKPCOST_TEXT2, value/2, DKPT['color']['tr'], DKPT['color']['tg'], DKPT['color']['tb'], DKPT['color']['vr'], DKPT['color']['vg'], DKPT['color']['vb'])
			end
		end
		tip:Show()
	end
	
end
-------- Tooltip hooking based on SellFish by Tuller. ----------

local function IsBagSlot(slot)
	return slot >= 20 and slot <= 23 or slot >= 68
end

local hooks = {
	SetHyperlink = function(link)
		return link
	end,

	SetLootItem = function(slot)
		if LootSlotHasItem(slot) then
			return GetLootSlotLink(slot)
		end
	end,

	SetLootRollItem = function(slot)
		return GetLootRollItemLink(slot)
	end,

	SetTradeTargetItem = function(id)
		return GetTradeTargetItemLink(id)
	end,

	SetBagItem = function(bag, slot)
		if not MerchantFrame:IsVisible() then
			return GetContainerItemLink(bag, slot)
		end
	end,

	SetInventoryItem = function(unit, slot)
		return GetInventoryItemLink(unit, slot)
	end,

	SetAuctionItem = function(type, index)
		return GetAuctionItemLink(type, index)
	end,

	SetAuctionSellItem = function()
		return select(2, GetItemInfo(GetAuctionSellItemInfo()))
	end,
--[[
	SetCraftItem = function(skill, id)
		return GetCraftReagentItemLink(skill, id)
	end,
]]--
	SetTradeSkillItem = function(skill, id)
		if id then
			return GetTradeSkillReagentItemLink(skill, id)
		end
		return GetTradeSkillItemLink(skill)
	end,

	SetQuestItem = function(type, index)
		return GetQuestItemLink(type, index)
	end,

	SetQuestLogItem = function(type, index)
		return GetQuestLogItemLink(type, index)
	end,

	SetInboxItem = function(id)
		return GetInboxItemLink(id)
	end,

	SetSendMailItem = function(id)
		return select(2, GetItemInfo(GetSendMailItem(id)))
	end,

	SetGuildBankItem = function(tab, slot)
		return GetGuildBankItemInfo(tab, slot)
	end,	
	
}

local function hookTip(tooltip, method, action)
	hooksecurefunc(tooltip, method, function(tip, ...)
		local link = action(...)
		if link then
			AddInfoToTooltip(tip, link)
		end
	end)
end

for method,func in pairs(hooks) do
	hookTip(GameTooltip, method, func)
end
hookTip(ItemRefTooltip, 'SetHyperlink', hooks.SetHyperlink)

----------------------------------------------------------------

	SLASH_DKPTOOLTIP1 = "/dkpt";
	SLASH_DKPTOOLTIP2 = "/dkptooltip";
	SlashCmdList["DKPTOOLTIP"] = DKPTooltip_Command;
end

function DKPTooltip_Command(msg)
	local cmd, subCmd = DKPTooltip_GetCmd(msg)
	if(cmd=="toggle") then
		DKPT['on']=not DKPT['on']
		if(DKPT['on']) then
			print("DKPTooltip - Showing the DKP-cost is now enabled.")
		else
			print("DKPTooltip - Showing the DKP-cost is now disabled.")
		end
	elseif(cmd=="halfcost") then
		DKPT['half']=not DKPT['half']
		if(DKPT['half']) then
			print("DKPTooltip - Showing the half DKP-cost.")
		else
			print("DKPTooltip - Not showing the half DKP-cost.")
		end
	elseif(cmd=="formula") then
		local cmd, subCmd = DKPTooltip_GetCmd(subCmd)
		if(tContains(types,cmd)) then
			DKPT['type']=cmd
			print("DKPTooltip - Formula changed successfully!")
		else
			print("DKPTooltip - Useage: '/dkpt formula <type>' where type is a supported formula.")
		end
	elseif(cmd=="types") then
		local msg="DKPTooltip - Currently supported formulas are:\n"..types[1]
		for i=2,#types do
			msg=msg..", "..types[i]
		end
		msg=msg.."."
		print(msg)
	elseif(cmd=="color") then
		local cmd, subCmd = DKPTooltip_GetCmd(subCmd)
		if(cmd=="text") then
			local tr, subCmd = DKPTooltip_GetCmd(subCmd)
			local tg, subCmd = DKPTooltip_GetCmd(subCmd)
			local tb, subCmd = DKPTooltip_GetCmd(subCmd)
			tr,tg,tb=tonumber(tr),tonumber(tg),tonumber(tb)
			if(tr==nil or tg==nil or tb==nil or tr<=0 or tr>=1 or tg<=0 or tg>=1 or tg<=0 or tb>=1) then
				DKPT['color']['tr'],DKPT['color']['tg'],DKPT['color']['tb']=tr,tg,tb
				print("DKPTooltip - Color on "..cmd.." changed successfully!")
			else
				print("DKPTooltip - Useage: '/dkpt color "..cmd.." <r> <g> <b>' where r, g, b are normalized rgb-values (i.e. '1 1 1' means '255 255 255' or 'FF FF FF').")
			end
		elseif(cmd=="value") then
			local vr, subCmd = DKPTooltip_GetCmd(subCmd)
			local vg, subCmd = DKPTooltip_GetCmd(subCmd)
			local vb, subCmd = DKPTooltip_GetCmd(subCmd)
			vr,vg,vb=tonumber(vr),tonumber(vg),tonumber(vb)
			if(vr==nil or vg==nil or vb==nil or vr<=0 or vr>=1 or vg<=0 or vg>=1 or vg<=0 or vb>=1) then
				DKPT['color']['vr'],DKPT['color']['vg'],DKPT['color']['vb']=vr,vg,vb
				print("DKPTooltip - Color on "..cmd.." changed successfully!")
			else
				print("DKPTooltip - Useage: '/dkpt color "..cmd.." <r> <g> <b>' where r, g, b are normalized rgb-values (i.e. '1 1 1' means '255 255 255' or 'FF FF FF').")
			end
		else
			print("DKPTooltip - Useage: '/dkpt color <text/value>'")
		end
	else
		print("DKPTooltip - Commands:\n 'toggle' to toggle dkp-cost on tooltips.\n 'halfcost' to toggle showing the half DKP-cost aswell.\n 'formula' to change the formula used to calculate prices.\n 'types' to see a list of currently supported formulas.\n 'color' to change the color in the tooltip.")
	end
end

function DKPTooltip_GetCmd(msg)
	if(msg) then
		local a,b,c = strfind(msg, "(%S+)")
		if(a) then
			return c, strsub(msg, b+2)
		else	
			return ""
		end
	end
end
